import type { ContainerGetMethod, EggContainer, EggObject, EggObjectName, EggProtoImplClass, EggPrototype, LifecycleContext, ObjectInitTypeLike, QualifierInfo } from '@eggjs/tegg-types';
export declare class EggContainerFactory {
    private static containerGetMethodMap;
    static registerContainerGetMethod(initType: ObjectInitTypeLike, method: ContainerGetMethod): void;
    static getContainer(proto: EggPrototype): EggContainer<LifecycleContext>;
    /**
     * get or create egg object
     * If get singleton egg object in context,
     * will create context egg object for it.
     */
    static getOrCreateEggObject(proto: EggPrototype, name?: EggObjectName): Promise<EggObject>;
    /**
     * get or create egg object from the Class
     * If get singleton egg object in context,
     * will create context egg object for it.
     */
    static getOrCreateEggObjectFromClazz(clazz: EggProtoImplClass, name?: EggObjectName, qualifiers?: QualifierInfo[]): Promise<EggObject>;
    /**
     * get or create egg object from the Name
     * If get singleton egg object in context,
     * will create context egg object for it.
     */
    static getOrCreateEggObjectFromName(name: EggObjectName, qualifiers?: QualifierInfo[]): Promise<EggObject>;
    static getEggObject(proto: EggPrototype, name?: EggObjectName): EggObject;
}
