import type { CreateObjectMethod, EggObject, EggObjectLifeCycleContext, EggObjectName, EggPrototype, EggPrototypeClass } from '@eggjs/tegg-types';
interface EggObjectPair {
    obj: EggObject;
    ctx: EggObjectLifeCycleContext;
}
export declare class EggObjectFactory {
    static eggObjectMap: Map<string, EggObjectPair>;
    static eggObjectCreateMap: Map<EggPrototypeClass, CreateObjectMethod>;
    static registerEggObjectCreateMethod(protoClass: EggPrototypeClass, method: CreateObjectMethod): void;
    static getEggObjectCreateMethod(protoClass: EggPrototypeClass): CreateObjectMethod;
    static createObject(name: EggObjectName, proto: EggPrototype): Promise<EggObject>;
    static destroyObject(obj: EggObject): Promise<void>;
}
export {};
