import type { EggObject, EggObjectLifeCycleContext, EggObjectName, EggPrototype } from '@eggjs/tegg-types';
export default class EggObjectImpl implements EggObject {
    private _obj;
    private status;
    readonly proto: EggPrototype;
    readonly name: EggObjectName;
    readonly id: string;
    constructor(name: EggObjectName, proto: EggPrototype);
    initWithInjectProperty(ctx: EggObjectLifeCycleContext): Promise<void>;
    initWithInjectConstructor(ctx: EggObjectLifeCycleContext): Promise<void>;
    init(ctx: EggObjectLifeCycleContext): Promise<void>;
    destroy(ctx: EggObjectLifeCycleContext): Promise<void>;
    injectProperty(name: EggObjectName, descriptor: PropertyDescriptor): void;
    get obj(): object;
    get isReady(): boolean;
    static createObject(name: EggObjectName, proto: EggPrototype, lifecycleContext: EggObjectLifeCycleContext): Promise<EggObjectImpl>;
}
