import type { EggObject, EggObjectName, EggPrototype, EggPrototypeName, LoadUnit, LoadUnitInstance, LoadUnitInstanceLifecycleContext } from '@eggjs/tegg-types';
export declare class ModuleLoadUnitInstance implements LoadUnitInstance {
    readonly loadUnit: LoadUnit;
    readonly id: string;
    readonly name: string;
    private protoToCreateMap;
    private eggObjectMap;
    private eggObjectPromiseMap;
    constructor(loadUnit: LoadUnit);
    iterateProtoToCreate(): IterableIterator<[EggObjectName, EggPrototype]>;
    addProtoToCreate(name: string, proto: EggPrototype): void;
    deleteProtoToCreate(name: string): void;
    init(ctx: LoadUnitInstanceLifecycleContext): Promise<void>;
    destroy(): Promise<void>;
    getOrCreateEggObject(name: EggPrototypeName, proto: EggPrototype): Promise<EggObject>;
    getEggObject(name: EggPrototypeName, proto: EggPrototype): EggObject;
    static createModuleLoadUnitInstance(ctx: LoadUnitInstanceLifecycleContext): LoadUnitInstance;
}
