import type { EggRuntimeContext, EggContextLifecycleContext, EggObject, EggObjectName, EggPrototype, EggPrototypeName } from '@eggjs/tegg-types';
export declare abstract class AbstractEggContext implements EggRuntimeContext {
    private contextData;
    private protoToCreate;
    private eggObjectMap;
    private eggObjectPromiseMap;
    private destroyed;
    abstract id: string;
    addProtoToCreate(name: string, proto: EggPrototype): void;
    deleteProtoToCreate(name: any): void;
    destroy(ctx: EggContextLifecycleContext): Promise<void>;
    get(key: string | symbol): any | undefined;
    getEggObject(name: EggPrototypeName, proto: EggPrototype): EggObject;
    getOrCreateEggObject(name: EggPrototypeName, proto: EggPrototype): Promise<EggObject>;
    init(ctx: EggContextLifecycleContext): Promise<void>;
    iterateProtoToCreate(): IterableIterator<[EggObjectName, EggPrototype]>;
    set(key: string | symbol, val: any): void;
}
